diff --git a/extmod/re1.5/compilecode.c b/extmod/re1.5/compilecode.c
index e4635f034a5..6a1ad460a2c 100644
--- a/extmod/re1.5/compilecode.c
+++ b/extmod/re1.5/compilecode.c
@@ -56,6 +56,14 @@ static const char *_compilecode(const char *re, ByteProg *prog, int sizecode)
                 if (!*re) return NULL;
                 EMIT(PC++, *re);
                 if (re[1] == '-') {
+                    if (re[2] == ']') {
+                        EMIT(PC++, *re);
+                        re += 1;
+                        cnt += 1;
+                        EMIT(PC++, *re);
+                        EMIT(PC++, *re);
+                        break;
+                    }
                     re += 2;
                 }
                 EMIT(PC++, *re);
diff --git a/tests/extmod/ure1.py b/tests/extmod/ure1.py
index 6075990fcb4..712fc8b4c51 100644
--- a/tests/extmod/ure1.py
+++ b/tests/extmod/ure1.py
@@ -39,6 +39,18 @@
 print(m)
 print("===")
 
+
+r = re.compile("[a-cu-z-]")
+m = r.match("-")
+print(m.group(0))
+m = r.match("]")
+print(m)
+r = re.compile("[-a-cu-z]")
+m = r.match("-")
+print(m.group(0))
+print("===")
+
+
 r = re.compile("[^a-cu-z]")
 m = r.match("a")
 print(m)
